#'
#' STrand-specific ANnotation of genomic data 
#' 
#' @name STAN-package
#' @docType package
#' @title STrand-specific ANnotation of genomic data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords package
#' @references B. Zacher, M. Lidschreiber, P. Cramer, J. Gagneur, and A. Tresch. Annotation of directed genomic states unveils variations in the Pol II transcription cycle. submitted, 2014.
#' @useDynLib STAN
NULL

#' The data for the Quick-Start example in the vignette
#'
#' @name example
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL


#' Initial bdHMM for the Quick-Start example in the vignette
#'
#' @name bdhmm_ex
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL


#' Pre-computed flag sequence for the Quick-Start example in the vignette
#'
#' @name flags
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' Initial HMM for the Quick-Start example in the vignette
#'
#' @name hmm_ex
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' Observation sequence of the Quick-Start example in the vignette
#'
#' @name observations
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL


#' Pre-defined flag sequence for the human CD4T-cell example
#'
#' @name humanCD4T_flags_ex
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' Processed ChIP-Seq signal for the human CD4T-cell example
#'
#' @name humanCD4T_signal_ex
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' Genomic positions of processed signal for the human CD4T-cell example
#'
#' @name humanCD4T_probeAnno_ex
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' UCSC gene annotation for the human CD4T-cell example
#'
#' @name humanCD4T_ucscGenes
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' Pre-computed initial estimates of the covairances for the human CD4T-cell example
#'
#' @name humanCD4T_initCovs
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' Pre-computed initial estimates of the means for the human CD4T-cell example
#'
#' @name humanCD4T_initMeans
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL


#' Ideogram track of human chromosome 7 for the human CD4T-cell example
#'
#' @name humanCD4T_ideogramChr7
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL


#' SGD annotation for the yeast TF example
#'
#' @name yeastTF_SGDGenes
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' Processed ChIP-on-chip data for yeast TF example
#'
#' @name yeastTF_databychrom_ex
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' Genomic positions of the ChIP-on-chip data for yeast TF example
#'
#' @name yeastTF_probeAnno_ex
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' Pre-computed initial estimates of the covairances for yeast TF example
#'
#' @name yeastTF_initCovs
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL

#' Pre-computed initial estimates of the means for yeast TF example
#'
#' @name yeastTF_initMeans
#' @docType data
#' @author Benedikt Zacher, Julien Gagneur, Achim Tresch
#' @keywords data
NULL 
